﻿using Abp;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DataTransmission.Joint
{
	public class Delay
	{
		private readonly CommonTool tool = new CommonTool();

		public DataTable GetDelay(string flowId)
		{
			var conn = tool.GetConSqlServer();
			var sql = $@" SELECT * FROM  dbo.Flow11_Postpone WHERE FPE_FlowID = {flowId} AND FPE_AuditFlag IN (1) ";
			return tool.GetDataTable(sql, conn);
		}

		public string GetDelaySql(DataTable data, DataRow row, string orderId, DataTable org, DataTable user) {
			var delayNum = 0;
			var pgDelaySql = string.Empty;
			foreach (DataRow delay in data.Rows)
			{
				var applyOrg = org.AsEnumerable().FirstOrDefault(x => x.Field<int?>("oldBmid").ToString() == delay["FPE_BMID"].ToString());
				var applyUser = user.AsEnumerable().FirstOrDefault(x => x.Field<int?>("oldUserId").ToString() == delay["FPE_UserID"].ToString());
				Entity.OrderDelay model = new Entity.OrderDelay();
				model.InitId();
				model.No = row["FSH_Code"].ToString().Trim();
				model.OrderId = orderId;
				model.ApplyDelayTime = DateTime.Parse(delay["FPE_FPDate"].ToString());
				model.ApplyOrgCode = delay["FPE_BMID"].ToString().ToString();
				model.CreatorOrgId = model.ApplyOrgCode;
				if (applyOrg != null) {
					model.ApplyOrgCode = applyOrg["Id"].ToString();
					model.ApplyOrgName = applyOrg["Name"].ToString();
					model.CreatorOrgId = applyOrg["Id"].ToString();
					model.AreaId = applyOrg["AreaId"].ToString();
					model.CreatorOrgName = applyOrg["Name"].ToString();
					model.CreatorOrgLevel = int.Parse(applyOrg["Level"].ToString());
				}
				model.EmployeeId = delay["FPE_UserID"].ToString();
				model.CreatorId = model.EmployeeId;
				if (applyUser != null)
				{
					model.EmployeeId = applyUser["Id"].ToString();
					model.CreatorId = applyUser["Id"].ToString();
					model.CreatorName = applyUser["Name"].ToString();
				}
				model.DelayNum = int.Parse(delay["FPE_SLimits"].ToString());
				model.DelayReason = delay["FPE_Reson"].ToString();
				model.AfterDelay = DateTime.Parse(delay["FPE_STTime"].ToString());
				model.DelayState = (Enum.EDelayState)int.Parse(delay["FPE_AuditFlag"].ToString());
				model.CreationTime = DateTime.Parse(delay["FPE_FPDate"].ToString());

				//if (delayNum == 0)
				//{
				//	pgDelaySql = $@"INSERT INTO ""public"".""order_delay"" (""Id"", ""No"", ""OrderId"", ""ApplyDelayTime"", ""ApplyOrgCode"", ""ApplyOrgName"", ""EmployeeId"", ""DelayNum"", ""DelayUnit"", ""DelayReason"",
				//				""BeforeDelay"", ""AfterDelay"", ""DelayState"", ""IsProDelay"", ""CreationTime"", ""CreatorOrgId"", ""CreatorId"", ""AreaId"", ""CreatorOrgName"", ""CreatorName"", ""CreatorOrgLevel"", 
				//				""WorkflowId"", ""FileJson"", ""EmployeeName"", ""ExpiredTimeConfigId"", ""FlowedOrgIds"", ""FlowedUserIds"", ""LastModificationTime"", ""IsDeleted"", ""DeletionTime"") VALUES 
				//				('{delayId}', '{row["FSH_Code"].ToString().Trim()}', '{orderId}', '{delay["FPE_FPDate"]}', '{VisitOrgCode}', '{delay["FPE_BMName"]}', '{EmployeeId}', '{delay["FPE_SLimits"]}', 2, '{delay["FPE_Reson"]}',
				//				NULL, '{delay["FPE_STTime"]}',{(int)model.DelayState}, 'f', '{delay["FPE_FPDate"]}', '{VisitOrgCode}', '08dc10ec-2dd8-4383-8426-b194c4f5e917', '', '{delay["FPE_BMName"]}', '张晓梅1', 1, '', NULL, '{delay["FPE_UserName"]}', NULL, NULL,NULL, NULL, 'f', NULL)";
				//}
				//else
				//{
				//	pgDelaySql += $@",('{delayId}', '{row["FSH_Code"].ToString().Trim()}', '{orderId}', '{delay["FPE_FPDate"]}', '{VisitOrgCode}', '{delay["FPE_BMName"]}', '{EmployeeId}', '{delay["FPE_SLimits"]}', 2, '{delay["FPE_Reson"]}', NULL, '{delay["FPE_STTime"]}',
				//			1, 'f', '{delay["FPE_FPDate"]}', '{VisitOrgCode}', '08dc10ec-2dd8-4383-8426-b194c4f5e917', '', '{delay["FPE_BMName"]}', '张晓梅1', 1, '', NULL, '{delay["FPE_UserName"]}', NULL, NULL, NULL, NULL, 'f', NULL)";
				//}
				delayNum++;
			}
			return pgDelaySql += ";";
		}
	}
}
